<?php
/**
 * Plugin CISTYLE
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/cistyle_commun');


function formulaires_cistyle_config_style_charger_dist() {

    if (!autoriser('configurer configuration'))
            return false;

    // valeurs actuelles
    $valeurs = cistyle_tableau_style();

    return $valeurs;
}

function formulaires_cistyle_config_style_verifier_dist(){
    $erreurs = array();
    $cistyle_tableau_nom_des_styles = cistyle_tableau_nom_des_styles();

    foreach ($cistyle_tableau_nom_des_styles AS $nom){
        list($balise,$attribut) = explode('_',trim($nom));
        if (_request($nom) AND !cistyle_verifier($attribut,_request($nom))){
                $erreurs[$nom] =  _T('cistyle:valeur_incorrecte');
        }
    }

    return $erreurs;
}

function formulaires_cistyle_config_style_traiter_dist(){
    
    $valeurs_actuelles = cistyle_tableau_style();
    $valeurs_futures = array();
    $res = array();
    $ok = false;	
    $tableau_styles = cistyle_tableau_nom_des_styles();

    foreach ($tableau_styles AS $style){        
        if ($valeur_saisie = _request($style)){
            if ($valeur_saisie != $valeurs_actuelles[$style]){
                $valeurs_actuelles[$style] = $valeur_saisie;
                $ok = true;
            }
        }
    }

    if ($ok){
        $nom = 'style';
        $valeurs_futures['valeur'] = serialize($valeurs_actuelles);

        $row = sql_fetsel('*', "spip_cistyle_config","nom='".$nom."'");
        if ($row) {
                sql_updateq("spip_cistyle_config", $valeurs_futures, "nom='".$nom."'");
        } else {
                $valeurs_futures['nom'] = $nom;
                sql_insertq('spip_cistyle_config', $valeurs_futures);
        }
    }
    
    $res['message_ok'] = "";
    $res['redirect'] = "";
    if (defined('_DIR_PLUGIN_CIBLOC')) {
        $res['redirect'] = generer_url_ecrire("configurer_cibloc");
    }
    
    return $res;	
}

function cistyle_extraire_attribut($nom){
    $attribut = '';
    if (!empty($nom)){
        list($balise,$attribut) = explode('_',trim($nom));
    }

    return $attribut;
}

function cistyle_choix_align($nom_element='',$valeur_element=''){
    $return = '';
    $selected = '';
    $disabled = '';
    if (cistyle_imposer_parametrage('style')){
        $disabled = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('left','center','right','justify');
    // Parcours du tableau
    $return .= '<select name="'.$nom_element.'" '.$disabled.'>'."n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_element){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function cistyle_choix_weight($nom_element='',$valeur_element=''){
    $return = '';
    $selected = '';
    $disabled = '';
    if (cistyle_imposer_parametrage('style')){
        $disabled = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('normal','bold','bolder','lighter','100','200','300','400','500','600','700','800','900','inherit','initial','unset');
    // Parcours du tableau
    $return .= '<select name="'.$nom_element.'" '.$disabled.'>'."\n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_element){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}


?>